Subject: Re: [PATCH v2 1/1] Makefile: add a prerequisite to the coverage-report target

From: Junio C Hamano <[email-masked]>
Date: Mon, 11 Apr 2022 15:59:34 -0700

Ævar Arnfjörð Bjarmason <[email-masked]> writes:

> I haven't come up with a patch for these coverage targets, but I think
> it would be much more useful to:
>
>  * Not have the target itself compile git, i.e. work like SANITIZE=leak,
>    there's no reason you shouldn't be able to e.g. combine the two
>    easily, it's just a complimentary set of flags.
>
>  * We should be able to run this in parallel, see
>    e.g. https://stackoverflow.com/questions/14643589/code-coverage-using-gcov-on-parallel-run
>    for a trick for how to do that on gcc 9+, on older gcc GCOV_PREFIX*
>    can be used.
>
>    I.e. we'd save these in t/test-results/t0001.coverage or whatever,
>    and then "join" them at the end.

I can see how this might lead to "Ah, *.coverage file exists so we
run report to show that existing result", but it is not reasonable
to say "we didn't touch t0001 so we do not have to rerun the script
under coverage-test" because whatever git subcommand we use may have
be updated (we _could_ describe the dependency fully so we only
re-run t0001 if any of t0001-init.sh, "git init", "git config", and
"git" is newer than the existing t0001.coverage; I do not know if
that is sensible, though).  And ...

> I wonder if the issue this patch is trying to address would then just go
> away, i.e. isn't it OK that we'd re-run the tests to get the report
> then? gcov doesn't add that much runtime overhead.

... I don't think overhead of gcov matters all that much.  Overhead
of "Having to" rerun tests primarily comes from running the tests,
with or without gcov enabled, so...

Or are you suggesting that we'd enable gcov in all our test runs by
default?